import { InjectionToken } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Router } from '@angular/router';
export declare type ParamDefType = 'boolean' | 'array' | 'number' | 'string';
declare type QueryParamParams<QueryParams = any> = {
    queryKey: keyof QueryParams & string;
    path?: string;
    type?: ParamDefType;
    strategy?: 'modelToUrl' | 'twoWay';
};
export declare class QueryParamDef<QueryParams = any> {
    private config;
    constructor(config: QueryParamParams<QueryParams>);
    get queryKey(): keyof QueryParams & string;
    get path(): string;
    get type(): ParamDefType;
    get strategy(): "modelToUrl" | "twoWay";
    parse(queryParamValue: string): any;
}
export declare class BindQueryParamsFactory {
    private router;
    private options;
    constructor(router: Router, options: BindQueryParamsOptions);
    create<T>(defs: QueryParamParams<T>[] | QueryParamParams<T>, group: FormGroup): BindQueryParamsManager<T>;
}
export declare class BindQueryParamsManager<T = any> {
    private router;
    private options;
    private defs;
    private group;
    private $destroy;
    connect(defs: QueryParamParams<T>[] | QueryParamParams<T>, group: FormGroup): this;
    constructor(router: Router, options: BindQueryParamsOptions);
    onInit(): void;
    destroy(): void;
    getDef(queryKey: keyof T): QueryParamDef<T>;
    parse(queryParams: Partial<T>): {};
    private updateQueryParams;
    private getInitialValue;
}
export interface BindQueryParamsOptions {
    windowRef: Window;
}
export declare const BIND_QUERY_PARAMS_OPTIONS: InjectionToken<{
    windowRef: Window & typeof globalThis;
}>;
export {};
